Index: lib/TWiki/Store.pm
===================================================================
--- lib/TWiki/Store.pm	(revision 1767)
+++ lib/TWiki/Store.pm	(working copy)
@@ -1096,148 +947,79 @@
 sub topicExists
 {
     my( $theWeb, $theTopic ) = @_;
-    ( $theWeb, $theTopic ) = normalizeWebTopicName( $theWeb, $theTopic );
+    ( $theWeb, $theTopic ) = TWiki::normalizeWebTopicName( $theWeb, $theTopic );
     return -e "$TWiki::dataDir/$theWeb/$theTopic.txt";
 }
 
-=pod
-
----++ sub getRevisionInfoFromMeta (  $web, $topic, $meta  )
-
-Try and get from meta information in topic, if this can't be done then use RCS.
-Note there is no "1." prefix to this data
-
-=cut
-
-sub getRevisionInfoFromMeta
-{
-    my( $web, $topic, $meta ) = @_;
-    
-    my( $date, $author, $rev );
-    my %topicinfo = ();
-    
-    if( $meta ) {
-        %topicinfo = $meta->findOne( "TOPICINFO" );
-    }
-        
-    if( %topicinfo ) {
-       # Stored as meta data in topic for faster access
-       $date = $topicinfo{"date"} ;
-       $author = $topicinfo{"author"};
-       my $tmp = $topicinfo{"version"};
-       $tmp =~ /1\.(.*)/o;
-       $rev = $1;
-    } else {
-       # Get data from RCS
-       ( $date, $author, $rev ) = getRevisionInfo( $web, $topic, "" );
-    }
-    
-    # writeDebug( "rev = $rev" );
-    
-    return( $date, $author, $rev );
+# PRIVATE parse and add a meta-datum. Returns "" so it can be used in s///e
+sub _addMetaDatum {
+    #my ( $meta, $type, $args ) = @_;
+    $_[0]->put( $_[1], _keyValue2Hash( $_[2] ));
+    return ""; # so it can be used in s///e
 }
 
-=pod
-
----++ sub convert2metaFormat (  $web, $topic, $text  )
-
-Not yet documented.
-
-=cut
-
-sub convert2metaFormat
-{
-    my( $web, $topic, $text ) = @_;
-    
-    my $meta = TWiki::Meta->new();
-    $text = $meta->read( $text );
-     
-    if ( $text =~ /<!--TWikiAttachment-->/ ) {
-       $text = TWiki::Attach::migrateToFileAttachmentMacro( $meta, $text );
-    }
-    
-    if ( $text =~ /<!--TWikiCat-->/ ) {
-       $text = TWiki::Form::upgradeCategoryTable( $web, $topic, $meta, $text );    
-    }
-    
-    return( $meta, $text );
-}
-
-=pod
-
----++ sub _extractMetaData (  $web, $topic, $fulltext  )
-
-Expect meta data at top of file, but willing to accept it anywhere.
-If we have an old file format without meta data, then convert.
-
-=cut
-
+# Expect meta data at top of file, but willing to accept it anywhere.
+# If we have an old file format without meta data, then convert.
+#
+# *WARNING: SIDE-EFFECTING FUNCTION* meta-data is stripped from the $text
 sub _extractMetaData
 {
-    my( $web, $topic, $fulltext ) = @_;
-    
-    my $meta = TWiki::Meta->new();
-    my $text = $meta->read( $fulltext );
+    #my( $web, $topic, $text ) = @_;
 
-    
-    # If there is no meta data then convert
+    my $meta = TWiki::Meta->new( $_[0], $_[1] );
+    $_[2] =~ s/^%META:([^{]+){(.*)}%\r?\n/&_addMetaDatum($meta,$1,$2)/gem;
+
+    # If there is no meta data then convert from old format
     if( ! $meta->count( "TOPICINFO" ) ) {
-        ( $meta, $text ) = convert2metaFormat( $web, $topic, $text );
+        if ( $_[2] =~ /<!--TWikiAttachment-->/ ) {
+            $_[2] = TWiki::Attach::migrateToFileAttachmentMacro( $meta,
+                                                                 $_[2] );
+        }
+
+        if ( $_[2] =~ /<!--TWikiCat-->/ ) {
+            $_[2] = TWiki::Form::upgradeCategoryTable( $_[0], $_[1],
+                                                       $meta, $_[2] );
+        }
     } else {
         my %topicinfo = $meta->findOne( "TOPICINFO" );
         if( $topicinfo{"format"} eq "1.0beta" ) {
             # This format used live at DrKW for a few months
-            if( $text =~ /<!--TWikiCat-->/ ) {
-               $text = TWiki::Form::upgradeCategoryTable( $web, $topic, $meta, $text );
+            if( $_[2] =~ /<!--TWikiCat-->/ ) {
+               $_[2] = TWiki::Form::upgradeCategoryTable( $_[0],
+                                                          $_[1],
+                                                          $meta,
+                                                          $_[2] );
             }
-            
             TWiki::Attach::upgradeFrom1v0beta( $meta );
-            
             if( $meta->count( "TOPICMOVED" ) ) {
                  my %moved = $meta->findOne( "TOPICMOVED" );
-                 $moved{"by"} = TWiki::wikiToUserName( $moved{"by"} );
+                 $moved{"by"} = TWiki::User::wikiToUserName( $moved{"by"} );
                  $meta->put( "TOPICMOVED", %moved );
             }
         }
     }
-    
-    return( $meta, $text );
-}
 
-=pod
-
----++ sub getFileName (  $theWeb, $theTopic, $theAttachment  )
-
-Not yet documented. <br/>
-*FIXME - get rid of this because uses private part of handler*
-
-=cut
-
-sub getFileName
-{
-    my( $theWeb, $theTopic, $theAttachment ) = @_;
-
-    my $topicHandler = _getTopicHandler( $theWeb, $theTopic, $theAttachment );
-    return $topicHandler->{file};
+    return $meta;
 }
 
 =pod
 
----++ sub readTopMeta (  $theWeb, $theTopic  )
+---++ sub getMinimalMeta (  $theWeb, $theTopic  ) -> $meta
 
-Just read the meta data at the top of the topic. <br/>
-Generalise for Codev.DataFramework, but needs to be fast because
-of use by view script.
+Get the minimum amount of meta-data necessary to find the
+topic parent.
+Generalised for Codev.DataFramework. Needs to be fast because
+of use by Render.pm.
 
 =cut
 
-sub readTopMeta
+sub getMinimalMeta
 {
     my( $theWeb, $theTopic ) = @_;
-    
+
     my $topicHandler = _getTopicHandler( $theWeb, $theTopic );
-    my $filename = getFileName( $theWeb, $theTopic );
-    
+    my $filename = $topicHandler->{file};
+
     my $data = "";
     my $line;
     $/ = "\n";     # read line by line
@@ -1249,12 +1031,9 @@
            $data .= $line;
         }
     }
-    
-    my( $meta, $text ) = _extractMetaData( $theWeb, $theTopic, $data );
-    
     close( IN_FILE );
 
-    return $meta;
+    return _extractMetaData( $theWeb, $theTopic, $data );
 }
 
 =pod
@@ -1274,11 +1053,10 @@
 sub readTopic
 {
     my( $theWeb, $theTopic, $internal ) = @_;
-    
-    my $fullText = readTopicRaw( $theWeb, $theTopic, "", $internal );
-    
-    my ( $meta, $text ) = _extractMetaData( $theWeb, $theTopic, $fullText );
-    
+
+    my $text = readTopicRaw( $theWeb, $theTopic, "", $internal );
+    my $meta = _extractMetaData( $theWeb, $theTopic, $text );
+    die "Internal error |$theWeb|$theTopic|" unless $meta;
     return( $meta, $text );
 }
 
@@ -1286,14 +1064,16 @@
 
 ---++ sub readWebTopic (  $theWeb, $theName  )
 
-Not yet documented.
+Reads and returns the raw text of a topic.
 
+SMELL: since the text returned contains META this method breaks the encapsulation of the Store. The only argument for this method is that it skips the extraction of meta-data from topics, which may be fractionally faster. I _believe_ it can be safely implemented to just return the topic text with no META.
+
 =cut
 
 sub readWebTopic
 {
     my( $theWeb, $theName ) = @_;
-    my $text = &readFile( "$TWiki::dataDir/$theWeb/$theName.txt" );
+    my $text = readFile( "$TWiki::dataDir/$theWeb/$theName.txt" );
     
     return $text;
 }
@@ -1308,6 +1088,8 @@
 is not granted, then an error message will be returned in $text, and set in
 $TWiki::readTopicPermissionFailed.
 
+SMELL: breaks encapsulation of the store, as it assumes meta is stored embedded in the text, and clients use this. Other implementors of store will be forced to insert meta-data to ensure correct operation of View raw=debug and the "repRev" mode of Edit.
+
 =cut
 
 sub readTopicRaw
@@ -1315,18 +1097,18 @@
     my( $theWeb, $theTopic, $theVersion, $internal ) = @_;
 
     #SVEN - test if theTopic contains a webName to override $theWeb
-    ( $theWeb, $theTopic ) = normalizeWebTopicName( $theWeb, $theTopic );
+    ( $theWeb, $theTopic ) = TWiki::normalizeWebTopicName( $theWeb, $theTopic );
 
     my $text = "";
     if( ! $theVersion ) {
-        $text = &readFile( "$TWiki::dataDir/$theWeb/$theTopic.txt" );
+        $text = readFile( "$TWiki::dataDir/$theWeb/$theTopic.txt" );
     } else {
         $text = _readVersionNoMeta( $theWeb, $theTopic, $theVersion);
     }
 
     my $viewAccessOK = 1;
     unless( $internal ) {
-        $viewAccessOK = &TWiki::Access::checkAccessPermission( "view", $TWiki::wikiUserName, $text, $theTopic, $theWeb );
+        $viewAccessOK = TWiki::Access::checkAccessPermission( "view", $TWiki::wikiUserName, $text, $theTopic, $theWeb );
         # TWiki::writeDebug( "readTopicRaw $viewAccessOK $TWiki::wikiUserName $theWeb $theTopic" );
     }
     
@@ -1343,238 +1125,6 @@
 
 =pod
 
----++ sub readTemplateTopic (  $theTopicName  )
-
-Not yet documented.
-
-=cut
-
-sub readTemplateTopic
-{
-    my( $theTopicName ) = @_;
-
-    $theTopicName =~ s/$TWiki::securityFilter//go;    # zap anything suspicious
-
-    # try to read in current web, if not read from TWiki web
-
-    my $web = $TWiki::twikiWebname;
-    if( topicExists( $TWiki::webName, $theTopicName ) ) {
-        $web = $TWiki::webName;
-    }
-    return readTopic( $web, $theTopicName );
-}
-
-=pod
-
----++ _readTemplateFile (  $theName, $theSkin  )
-Return value: raw template text, or "" if read fails
-
-WARNING! THIS FUNCTION DEPENDS ON GLOBAL VARIABLES
-
-PRIVATE Reads a template, constructing a candidate name for the template thus: $name.$skin.tmpl,
-and looking for a file of that name first in templates/$web and then if that fails in templates/.
-If a template is not found, tries to parse $name into a web name and a topic name, and
-read topic $Web.${Skin}Skin${Topic}Template. If $name does not contain a web specifier,
-$Web defaults to TWiki::twikiWebname. If no skin is specified, topic is ${Topic}Template.
-If the topic exists, checks access permissions and reads the topic
-without meta-data. In the event that the read fails (template not found, access permissions fail)
-returns the empty string "". skin, web and topic names are forced to an upper-case first character
-when composing user topic names.
-
-=cut
-
-sub _readTemplateFile
-{
-    my( $theName, $theSkin, $theWeb ) = @_;
-    $theSkin = "" unless $theSkin; # prevent 'uninitialized value' warnings
-
-    # CrisBailiff, PeterThoeny 13 Jun 2000: Add security
-    $theName =~ s/$TWiki::securityFilter//go;    # zap anything suspicious
-    $theName =~ s/\.+/\./g;                      # Filter out ".." from filename
-    $theSkin =~ s/$TWiki::securityFilter//go;    # zap anything suspicious
-    $theSkin =~ s/\.+/\./g;                      # Filter out ".." from filename
-
-    my $tmplFile = "";
-
-    # search first in twiki/templates/Web dir
-    # for file script(.skin).tmpl
-    my $tmplDir = "$TWiki::templateDir/$theWeb";
-    if( opendir( DIR, $tmplDir ) ) {
-        # for performance use readdir, not a row of ( -e file )
-        my @filelist = grep /^$theName\..*tmpl$/, readdir DIR;
-        closedir DIR;
-        $tmplFile = "$theName.$theSkin.tmpl";
-        if( ! grep { /^$tmplFile$/ } @filelist ) {
-            $tmplFile = "$theName.tmpl";
-            if( ! grep { /^$tmplFile$/ } @filelist ) {
-                $tmplFile = "";
-            }
-        }
-        if( $tmplFile ) {
-            $tmplFile = "$tmplDir/$tmplFile";
-        }
-    }
-
-    # if not found, search in twiki/templates dir
-    $tmplDir = $TWiki::templateDir;
-    if( ( ! $tmplFile ) && ( opendir( DIR, $tmplDir ) ) ) {
-        my @filelist = grep /^$theName\..*tmpl$/, readdir DIR;
-        closedir DIR;
-        $tmplFile = "$theName.$theSkin.tmpl";
-        if( ! grep { /^$tmplFile$/ } @filelist ) {
-            $tmplFile = "$theName.tmpl";
-            if( ! grep { /^$tmplFile$/ } @filelist ) {
-                $tmplFile = "";
-            }
-        }
-        if( $tmplFile ) {
-            $tmplFile = "$tmplDir/$tmplFile";
-        }
-    }
-
-    # See if it is a user topic. Search first in current web
-    # twiki web. Note that neither web nor topic may be variables when used in a template.
-    if ( ! $tmplFile ) {
-	if ( $theSkin ne "" ) {
-	    $theSkin = ucfirst( $theSkin ) . "Skin";
-	}
-
-	my $theTopic;
-	my $theWeb;
-
-	if ( $theName =~ /^(\w+)\.(\w+)$/ ) {
-	    $theWeb = ucfirst( $1 );
-	    $theTopic = ucfirst( $2 );
-	} else {
-	    $theWeb = $TWiki::webName;
-	    $theTopic = $theSkin . ucfirst( $theName ) . "Template";
-	    if ( !TWiki::Store::topicExists( $theWeb, $theTopic )) {
-		$theWeb = $TWiki::twikiWebname;
-	    }
-	}
-
-	if ( TWiki::Store::topicExists( $theWeb, $theTopic ) &&
-		TWiki::Access::checkAccessPermission( "view",
-		    $TWiki::wikiUserName, "", $theTopic, $theWeb )) {
-	    my ( $meta, $text ) = TWiki::Store::readTopic( $theWeb, $theTopic, 1 );
-	    return $text;
-	}
-    }
-
-    # read the template file
-    if( -e $tmplFile ) {
-        return &readFile( $tmplFile );
-    }
-    return "";
-}
-
-=pod
-
----++ sub handleTmplP (  $theVar  )
-Return value: expanded text of the named template, as found from looking in the global register of template definitions.
-
-WARNING! THIS FUNCTION DEPENDS ON GLOBAL VARIABLES
-
-If $theVar is the name of a previously defined template, returns the text of
-that template after recursive expansion of any TMPL:P tags it contains.
-
-=cut
-
-sub handleTmplP
-{
-    # Print template variable, called by %TMPL:P{"$theVar"}%
-    my( $theVar ) = @_;
-
-    my $val = "";
-    if( ( %templateVars ) && ( exists $templateVars{ $theVar } ) ) {
-        $val = $templateVars{ $theVar };
-        $val =~ s/%TMPL\:P{[\s\"]*(.*?)[\"\s]*}%/&handleTmplP($1)/geo;  # recursion
-    }
-    if( ( $theVar eq "sep" ) && ( ! $val ) ) {
-        # set separator explicitely if not set
-        $val = " | ";
-    }
-    return $val;
-}
-
-=pod
-
----++ sub readTemplate ( $theName, $theSkin, $theWeb )
-Return value: expanded template text
-
-WARNING! THIS IS A SIDE-EFFECTING FUNCTION
-
-PUBLIC Reads a template, constructing a candidate name for the template as described in
-_readTemplateFile.
-
-If template text is found, extracts include statements and fully expands them.
-Also extracts template definitions and adds them to the
-global templateVars hash, overwriting any previous definition.
-
-=cut
-
-sub readTemplate
-{
-    my( $theName, $theSkin, $theWeb ) = @_;
-
-    if( ! defined($theSkin) ) {
-        $theSkin = &TWiki::getSkin();
-    }
-
-    if( ! defined( $theWeb ) ) {
-      $theWeb = $TWiki::webName;
-    }
-
-    # recursively read template file(s)
-    my $text = _readTemplateFile( $theName, $theSkin, $theWeb );
-    while( $text =~ /%TMPL\:INCLUDE{[\s\"]*(.*?)[\"\s]*}%/s ) {
-        $text =~ s/%TMPL\:INCLUDE{[\s\"]*(.*?)[\"\s]*}%/&_readTemplateFile( $1, $theSkin, $theWeb )/geo;
-    }
-
-    if( ! ( $text =~ /%TMPL\:/s ) ) {
-        # no template processing
-        $text =~ s|^(( {3})+)|"\t" x (length($1)/3)|geom;  # leading spaces to tabs
-        return $text;
-    }
-
-    my $result = "";
-    my $key  = "";
-    my $val  = "";
-    my $delim = "";
-    foreach( split( /(%TMPL\:)/, $text ) ) {
-        if( /^(%TMPL\:)$/ ) {
-            $delim = $1;
-        } elsif( ( /^DEF{[\s\"]*(.*?)[\"\s]*}%[\n\r]*(.*)/s ) && ( $1 ) ) {
-            # handle %TMPL:DEF{"key"}%
-            if( $key ) {
-                $templateVars{ $key } = $val;
-            }
-            $key = $1;
-            $val = $2 || "";
-
-        } elsif( /^END%[\n\r]*(.*)/s ) {
-            # handle %TMPL:END%
-            $templateVars{ $key } = $val;
-            $key = "";
-            $val = "";
-            $result .= $1 || "";
-
-        } elsif( $key ) {
-            $val    .= "$delim$_";
-
-        } else {
-            $result .= "$delim$_";
-        }
-    }
-
-    # handle %TMPL:P{"..."}% recursively
-    $result =~ s/%TMPL\:P{[\s\"]*(.*?)[\"\s]*}%/&handleTmplP($1)/geo;
-    $result =~ s|^(( {3})+)|"\t" x (length($1)/3)|geom;  # leading spaces to tabs
-    return $result;
-}
-
-=pod
-
 ---++ readFile( $filename )
 Return value: $fileContents
 
@@ -1583,6 +1133,10 @@
 any $filename coming from a user is stripped of special characters that might
 change Perl's open() semantics.
 
+Used for reading side-files of meta-data, such as fileTypes, changes, etc.
+
+SMELL: Breaks Store encapsulation, if it is used to read files other than the standard meta-files (e.g. if it is used to read topic files)
+
 =cut
 
 sub readFile
@@ -1603,8 +1157,10 @@
 
 ---++ sub readFileHead (  $name, $maxLines  )
 
-Not yet documented.
+Returns $maxLines of content from the head of the given file-system file.
 
+SMELL: breaks Store encapsulation, if it is used to access topics or attachments under the control of Store.
+
 =cut
 
 sub readFileHead
@@ -1623,9 +1179,6 @@
     return $data;
 }
 
-
-#AS 5 Dec 2000 collect all Web's topic names
-
 =pod
 
 ---+++ getTopicNames( $web ) ==> @topics
@@ -1651,24 +1204,24 @@
     closedir( DIR );
     return @topicList ;    
 }
-#/AS
 
-
-#AS 5 Dec 2000 collect immediate subWeb names
-
 =pod
 
 ---++ sub getSubWebs (  $web  )
 
-Not yet documented.
+gets a list of sub-webs contained in the given named web. If the
+web is null, it gets a list of all top-level webs. $web may
+be a pathname at any level of the hierarchy; for example, it may be
+Dadweb/Kidweb/Petweb. Includes hidden webs (those starting with
+non-alphanumeric characters).
 
 =cut
 
 sub getSubWebs {
     my( $web ) = @_ ;
-    
+
     if( !defined $web ) {
-	$web="";
+        $web="";
     }
 
     #FIXME untaint web name?
@@ -1680,52 +1233,53 @@
 
     # this is not magic, it just looks like it.
     my @webList = sort
-        grep { s#^.+/([^/]+)$#$1# }
-        grep { -d }
-        map  { "$TWiki::dataDir/$web/$_" }
-        grep { ! /^\.\.?$/ } @tmpList;
+      grep { !/^\.\.?$/ && -d "$TWiki::dataDir/$web/$_" }
+        @tmpList;
 
     return @webList ;
 }
-#/AS
 
 
 # =========================
-#AS 26 Dec 2000 recursively collects all Web names
-#FIXME: move var to TWiki.cfg ?
-use vars qw ($subWebsAllowedP);
+# CC: removed - useless.
+#use vars qw ($subWebsAllowedP);
 
-$subWebsAllowedP = 0; # 1 = subwebs allowed, 0 = flat webs
+#$subWebsAllowedP = 0; # 1 = subwebs allowed, 0 = flat webs
 
 =pod
 
----++ sub getAllWebs (  $web  )
+---++ sub getAllWebs() -> list of web names
 
-Not yet documented.
+Gets a list of webnames, of webs contained within the given
+web. Potentially able to expand recursively, but this is
+commented out as support is lacking for subwebs almost everywhere
+else.
 
 =cut
 
 sub getAllWebs {
     # returns a list of subweb names
     my( $web ) = @_ ;
-    
+
     if( !defined $web ) {
-	$web="";
+        $web="";
     }
-    my @webList =   map { s/^\///o; $_ }
-		    map { "$web/$_" }
-		    &getSubWebs( $web );
-    my $subWeb = "";
-    if( $subWebsAllowedP ) {
-        my @subWebs = @webList;
-	foreach $subWeb ( @webList ) {
-	    push @subWebs, &getAllWebs( $subWeb );
-	}
-	return @subWebs;
-    }
+
+    my @webList =
+      map { s/^\///o; $_ } # remove leading /
+        map { "$web/$_" }
+          &getSubWebs( $web );
+
+#cc    my $subWeb = "";
+#cc    if( $subWebsAllowedP ) {
+#cc        my @subWebs = @webList;
+#cc        foreach $subWeb ( @webList ) {
+#cc            push @subWebs, &getAllWebs( $subWeb );
+#cc        }
+#cc        return @subWebs;
+#cc    }
     return @webList ;
 }
-#/AS
 
 =pod
 
@@ -1751,10 +1305,114 @@
     return $topicHandler->setTopicRevisionTag( $web, $topic, $rev, $tag );
 }
 
+# Write a meta-data key=value pair
+sub _writeKeyValue {
+    my( $key, $value ) = @_;
 
+    $value =~ s/\r\r\n/%_N_%/go;
+    $value =~ s/\r\n/%_N_%/go;
+    $value =~ s/\n\r/%_N_%/go;
+    $value =~ s/\r\n/%_N_%/go; # Deal with doubles or \n\r
+    $value =~ s/\r/\n/go;
+    $value =~ s/\n/%_N_%/go;
+    $value =~ s/"/%_Q_%/go;
 
+    return "$key=\"$value\"";
+}
+
+# Write all the key=value pairs for the types listed
+sub _writeTypes {
+    my( $meta, @types ) = @_;
+    
+    my $text = "";
+
+    if( $types[0] eq "not" ) {
+        # write all types that are not in the list
+        my %seen;
+        @seen{ @types } = ();
+        @types = ();  # empty "not in list"
+        foreach my $key ( keys %$meta ) {
+            push( @types, $key ) unless
+              (exists $seen{ $key } || $key =~ /^_/);
+        }
+    }
+    
+    foreach my $type ( @types ) {
+        my $data = $meta->{$type};
+        foreach my $item ( @$data ) {
+            my $sep = "";
+            $text .= "%META:$type\{";
+            my $name = $item->{"name"};
+            if( $name ) {
+                # If there's a name field, put first to make regexp based searching easier
+                $text .= _writeKeyValue( "name", $item->{"name"} );
+                $sep = " ";
+            }
+            foreach my $key ( sort keys %$item ) {
+                if( $key ne "name" ) {
+                    $text .= $sep;
+                    $text .= _writeKeyValue( $key, $item->{$key} );
+                    $sep = " ";
+                }
+            }
+            $text .= "\}%\n";
+         }
+    }
+
+    return $text;
+}
+
+# Meta data for start of topic
+sub _writeStart
+{
+    my( $meta ) = @_;
+    
+    return _writeTypes( $meta, qw/TOPICINFO TOPICPARENT/ );
+}
+
+# Meta data for end of topic
+sub _writeEnd
+{
+    my( $meta ) = @_;
+
+    my $text = _writeTypes($meta, qw/FORM FIELD FILEATTACHMENT TOPICMOVED/ );
+    # append remaining meta data
+    $text .= _writeTypes( $meta, qw/not TOPICINFO TOPICPARENT FORM FIELD FILEATTACHMENT TOPICMOVED/ );
+    return $text;
+}
+
+# ===========================
+# Prepend/append meta data to topic
+sub _writeMeta
+{
+    my( $meta, $text ) = @_;
+    
+    my $start = _writeStart( $meta );
+    my $end = _writeEnd( $meta );
+    $text = $start . "$text";
+    $text =~ s/([^\n\r])$/$1\n/;     # new line is required at end
+    $text .= $end;
+    
+    return $text;
+}
+
+=pod
+
+---++ sub getDebugText($meta, $text) -> $text
+Generate a debug text form of the text/meta, for use in debug displays,
+by annotating the text with meta informtion.
+
+=cut
+
+sub getDebugText {
+    my ( $meta, $text ) = @_;
+
+    return _writeMeta( $meta, $text );
+}
+
 # =========================
 
 1;
 
 # EOF
+
